(* https://github.com/janestreet/base/blob/master/src/option.ml#L108 Like
   https://doc.rust-lang.org/std/option/enum.Option.html#method.unwrap_or_else *)
let value_or_thunk (o : 'a option) ~(default : unit -> 'a) : 'a =
  match o with
  | Some x -> x
  | None -> default ()
;;

let list_from_fn (f : unit -> 'a option) : 'a list =
  let rec next list =
    match f () with
    | None -> list
    | Some e -> next (e :: list)
  in
  next [] |> List.rev
;;
